//
// anyRemote
// a bluetooth remote for your PC.
//
// Copyright (C) 2012-2012 Mikhail Fedotov <anyremote@mail.ru>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// Hash related wrappers
//

#ifndef _HASH_H_
#define _HASH_H_ 1

#include <lib_wrapper.h>

#ifdef USE_GLIB

#include <glib.h>
typedef GHFunc HashForeachFunc;

# else 

typedef void (*HashForeachFunc) (void* key, void* value, void* data);

#endif

enum HashID {
    H_VAR = 0,
    H_TIMER,
    H_MAX
};

int   hashNew    (int id, DestroyCallback func);
void  hashReplace(int id, const char* key, void *value); 
void* hashFind   (int id, const char* key); 
int   hashRemove (int id, const char* key);
void  hashDestroy(int id);
void  hashForeach(int id, HashForeachFunc func, void *data);
int   hashExists (int id);

#endif
